"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var generateQueryMethod_1 = require("./generate/generateQueryMethod");
var generateMutationMethod_1 = require("./generate/generateMutationMethod");
var generateSubscriptionMethod_1 = require("./generate/generateSubscriptionMethod");
var rootType_1 = require("../utils/rootType");
var renderRootTypeClass_1 = require("./render/renderRootTypeClass");
var capitalizeFirstLetter_1 = require("../utils/capitalizeFirstLetter");
exports.default = (function (typeName, otherTypes) { return function (queryType) {
    var _a;
    if (!queryType ||
        (queryType.kind !== 'OBJECT') ||
        !queryType.fields ||
        !queryType.fields.length) {
        return null;
    }
    var generateOptions = (_a = {},
        _a[rootType_1.RootType.Query.toString()] = generateQueryMethod_1.default,
        _a[rootType_1.RootType.Mutation.toString()] = generateMutationMethod_1.default,
        _a[rootType_1.RootType.Subscription.toString()] = generateSubscriptionMethod_1.default,
        _a);
    var generateMethod = generateOptions[typeName];
    var methodsAndProps = queryType.fields
        .map(function (x) { return generateMethod(x, otherTypes); });
    var methodProps = methodsAndProps
        .map(function (x) { return x.props; })
        .filter(function (x) { return !!x; });
    var methods = methodsAndProps
        .map(function (x) { return x.method; });
    var className = capitalizeFirstLetter_1.default(typeName);
    return renderRootTypeClass_1.default({
        className: className,
        renderPropTypes: function () { return methodProps.join('\n'); },
        renderMethods: function () { return methods.join('\n'); },
    });
}; });
