"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function generateResultTypeFields(type, allTypes) {
    switch (type.kind) {
        case 'ENUM':
        case 'SCALAR':
            return null;
        case 'NON_NULL':
        case 'LIST':
            return generateResultTypeFields(type.ofType, allTypes);
        case 'INTERFACE':
            {
                var resultType = allTypes.find(function (x) { return x.name === type.name; });
                if (!resultType) {
                    return null;
                }
                return resultType.fields
                    .map(function (x) { return x.name; });
            }
        case 'OBJECT':
            {
                var resultType = allTypes.find(function (x) { return x.name === type.name; });
                if (!resultType) {
                    return null;
                }
                return resultType.fields
                    .map(function (x) { return x.name; });
            }
        default:
            console.log('MISSING RESULT TYPE', type.kind);
            return null;
    }
}
exports.default = generateResultTypeFields;
