"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getTypescriptField(fieldName, type, _a) {
    var isNull = _a.isNull, isList = _a.isList;
    switch (type.kind) {
        case 'INPUT_OBJECT':
        case 'ENUM':
        case 'OBJECT':
        case 'INTERFACE':
        case 'SCALAR':
        case 'UNION':
            return buildField(fieldName, type.name, isNull, isList);
        case 'SCALAR':
            return buildField(fieldName, type.name, isNull, isList);
        case 'NON_NULL':
            return getTypescriptField(fieldName, type.ofType, { isList: isList, isNull: true });
        case 'LIST':
            return getTypescriptField(fieldName, type.ofType, { isList: true, isNull: isNull });
        default:
            throw new Error("UNKNOWN_TYPE_KIND");
    }
}
exports.default = getTypescriptField;
var buildField = function (fieldName, typeName, isNull, isList) {
    var nullableSymbol = isNull ? '' : '?';
    var arraySymbol = isList ? '[]' : '';
    return "" + fieldName + nullableSymbol + ": " + typeName + arraySymbol;
};
