"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rootType_1 = require("../../utils/rootType");
function default_1(_a) {
    var rootType = _a.rootType, hasVariables = _a.hasVariables, returnType = _a.returnType;
    var _b;
    var methodName = (_b = {},
        _b[rootType_1.RootType.Query] = 'query',
        _b[rootType_1.RootType.Mutation] = 'mutate',
        _b[rootType_1.RootType.Subscription] = 'subscribe',
        _b)[rootType];
    return "\t// apollo call\n\t\treturn this.client." + methodName + "({\n\t\t\t" + rootType + "," + (hasVariables ? "\n\t\t\tvariables: props," : '') + "\n\t\t}).then(result => {\n\t\t\t// if error, throw it\n\t\t\tif (result.errors) {\n\t\t\t\tthrow new Error(<any>result.errors)\n\t\t\t}\n\n\t\t\t// cast the result and return (need any for scalar types, to avoid compilation error)\n\t\t\treturn <" + returnType + "><any>result.data\n\t\t})";
}
exports.default = default_1;
