"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function default_1(type) {
    var fieldNames = [];
    if (type.kind === 'OBJECT' || type.kind === 'INTERFACE') {
        fieldNames = type.fields
            .filter(function (x) { return isKindAllowed(x.type); })
            .map(function (x) { return "\t\t\t\t" + x.name; });
    }
    return "\t\tif (!fragment) {\n\t\t\tfragment = `{\n" + fieldNames.join('\n') + "\n\t\t\t}`\n\t\t}\n";
}
exports.default = default_1;
function isKindAllowed(type) {
    switch (type.kind) {
        case 'ENUM':
        case 'SCALAR':
            return true;
        case 'NON_NULL':
        case 'LIST':
            return isKindAllowed(type.ofType);
        default:
            return false;
    }
}
