#! /usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var program = require("commander");
var run_1 = require("./run");
var pkg = require('../package.json');
program
    .description(pkg.description)
    .version(pkg.version)
    .usage('example: `gcg --endpointUrl https://server.jok.io --outputUrl src/generated/test.ts`')
    // .arguments('<project-directory>')
    .option('--endpointUrl <endpointUrl>', 'graphql endpoint url', /.+/i)
    .option('--outputUrl </usr/local/lib>', 'result file address', /.+/i)
    // .allowUnknownOption()
    .parse(process.argv);
var endpointUrl = program.endpointUrl;
var outputUrl = program.outputUrl;
if (!endpointUrl || !outputUrl) {
    console.log('please enter --endpointUrl & --outputUrl parameters');
}
else {
    run_1.default({
        graphqlUrl: endpointUrl,
        outputUrl: outputUrl,
    });
}
