#! /usr/bin/env node

import * as program from 'commander'
import run from './run'
const pkg = require('../package.json')

program
	.description(pkg.description)
	.version(pkg.version)
	.usage('example: `gcg --endpointUrl https://server.jok.io --outputUrl src/generated/test.ts`')
	// .arguments('<project-directory>')
	.option('--endpointUrl <endpointUrl>', 'graphql endpoint url', /.+/i)
	.option('--outputUrl </usr/local/lib>', 'result file address', /.+/i)
	// .allowUnknownOption()
	.parse(process.argv)


const endpointUrl = program.endpointUrl
const outputUrl = program.outputUrl

if (!endpointUrl || !outputUrl) {
	console.log('please enter --endpointUrl & --outputUrl parameters')
} else {
	run({
		graphqlUrl: endpointUrl,
		outputUrl,
	})
}
